import javax.swing.*;
import java.awt.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

public class Oberflaeche extends JFrame { // Das ist der Fensterrahmen des Programms
  private Steuerung dieSteuerung;
  public  NordPanel dasNordPanel = new NordPanel(this);
  public  MittePanel dasMittePanel = new MittePanel();
  public  OstPanel dasOstPanel = new OstPanel(this);
  public  SuedPanel dasSuedPanel = new SuedPanel();

  public Oberflaeche() {    // Die Steuerung ist eine extra Klasse
    getContentPane().add(new MyContainer(this)); // Den Container in den Fensterrahmen eingebaut
    setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE ); // Beenden wenn Rahmen geschlossen
    dieSteuerung = new Steuerung(this);
    dieSteuerung.resetSPS();
  }
  public void clickTaster(int n){dieSteuerung.simmuliereSPS(n);}
  public void clickResetSPS(){dieSteuerung.resetSPS();}
  public void clickNaechsteDZ(){dieSteuerung.naechsteDZ();}
  public void ausgebenLED(int n){
    dasSuedPanel.ausgeben(n);
  }
  public void setzeTaster(int n){
    dasNordPanel.setTaster(n);
  }
  public void loescheText(){
    dasMittePanel.dieTextArea.setText("");
  }
  public void ausgebenText(String s){
    dasMittePanel.dieTextArea.append(s);
  }

  public static void main(String[] args) { // Main Methode zum starten der Applikation
    Oberflaeche dieOberflaeche = new Oberflaeche();   // Das Fenster wird erzeugt
    dieOberflaeche.setSize(500,400);                  // Die Groesse wird festgelegt
    dieOberflaeche.setTitle("SPS-Simulator V1.1 (c) Oliver Mezger 23.1.22");
    dieOberflaeche.setVisible(true);
  }
}

class MyContainer extends Container { // Ein Container nimmt die einzelnen Panele auf
  public MyContainer(Oberflaeche o){
    setLayout(new BorderLayout(10,10));
    add(o.dasNordPanel, BorderLayout.NORTH );
    add(o.dasOstPanel, BorderLayout.EAST );
    add(o.dasMittePanel, BorderLayout.CENTER );
    add(o.dasSuedPanel, BorderLayout.SOUTH );
  } 
}
  
class NordPanel extends JPanel{
  private final Oberflaeche dieOberflaeche;
  private final JLabel eingabeLabel = new JLabel("0b000");
  private final JToggleButton t2 = new JToggleButton("T2");
  private final JToggleButton t1 = new JToggleButton("T1");
  private final JToggleButton t0 = new JToggleButton("T0");
  private int taster;
  
  public NordPanel(Oberflaeche o){
    dieOberflaeche=o;
    setBackground(Color.yellow);
    setLayout(new FlowLayout());
    add(new JLabel("Eingabe-Taster "));
    add(t2);
    add(t1);
    add(t0);
    add(eingabeLabel);
    t2.addMouseListener(new MouseAdapter() {
      @Override
      public void mousePressed(MouseEvent e) {
        taster ^=4;
        clickTaste();
      }
    });
    t1.addMouseListener(new MouseAdapter() {
      @Override
      public void mousePressed(MouseEvent e) {
        taster ^=2;
        clickTaste();
      }
    });
    t0.addMouseListener(new MouseAdapter() {
      @Override
      public void mousePressed(MouseEvent e) {
        taster ^=1;
        clickTaste();
      }
    });
  }
  public void clickTaste(){
    eingabeLabel.setText(""+ taster);
    dieOberflaeche.clickTaster(taster);
  }
  public void setTaster(int n){
    t2.setSelected((n&4)!=0);
    t1.setSelected((n&2)!=0);
    t0.setSelected((n&1)!=0);
    taster=n;
  }
}
class OstPanel extends JPanel{
  private final Oberflaeche dieOberflaeche;
  public OstPanel(Oberflaeche o){
    dieOberflaeche = o;
    JButton tmp;
    setBackground(Color.green);
    setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
    add(Box.createVerticalStrut(20));
    tmp = new JButton("ResetSPS");
    add (tmp);
    tmp.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        dieOberflaeche.clickResetSPS();
      }
    });
    add(Box.createVerticalStrut(20));
    tmp = new JButton("DZ++");
    add (tmp);
    tmp.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mousePressed(MouseEvent e) {
        dieOberflaeche.clickNaechsteDZ();
      }
    });
    add(Box.createVerticalStrut(20));
    add(Box.createVerticalGlue());
  }
}
class MittePanel extends JPanel{
  public final JTextArea dieTextArea = new JTextArea(8,20);
  public MittePanel(){
    setBackground(Color.white);
    setLayout(new FlowLayout());
    add(dieTextArea);
    Font font= new Font("Courier", Font.PLAIN, 14);
    dieTextArea.setFont(font);
  }
}
class SuedPanel extends JPanel{
  private final JRadioButton l3 = new JRadioButton("L3");
  private final JRadioButton l2 = new JRadioButton("L2");
  private final JRadioButton l1 = new JRadioButton("L1");
  private final JRadioButton l0 = new JRadioButton("L0");
  public SuedPanel(){
    setBackground(Color.orange);
    setLayout(new FlowLayout());
    add(new JLabel("Ausgabe-LED"));
    add(l3);
    add(l2);
    add(l1);
    add(l0);
  }
  public void ausgeben(int n){
    l3.setSelected((n&8)!=0);
    l2.setSelected((n&4)!=0);
    l1.setSelected((n&2)!=0);
    l0.setSelected((n&1)!=0);
  }
}