public class Steuerung {
  private Oberflaeche dieOberflaeche;
  private final SPS dieSPS;

  public Steuerung(Oberflaeche o) {
    dieOberflaeche = o;
    dieSPS = new SPS();
  }

  public void resetSPS() {
    dieSPS.reset();
    dieOberflaeche.setzeTaster(0);
    dieOberflaeche.ausgebenLED(dieSPS.getAusgabe());
    dieOberflaeche.loescheText();
    dieOberflaeche.ausgebenText("DZ Taster | LED");
    simmuliereSPS(0);
  }

  public void simmuliereSPS(int e) {
    dieSPS.setEingabe(e);
    dieSPS.simulation();
    dieOberflaeche.ausgebenLED(dieSPS.getAusgabe());
    dieOberflaeche.ausgebenText(String.format("\n %d %4s   | %4s", e, intToBin(e, 3), intToBin(dieSPS.getAusgabe(), 4)));
  }

  public void naechsteDZ() {
    int ein = dieSPS.getEingabe();
    if (ein < 7) {
      ein++;
      dieOberflaeche.setzeTaster(ein);
      simmuliereSPS(ein);
    }
  }

  private String intToBin(int n, int a) { // formatierte Bitausgabe
    String s = "";                        // n ist die auszugebende Zahl
    for (int i = 0; i < a; i++) {         // a sind die Anzahl der Stellen
      if (n % 2 > 0)
        s = "1" + s;
      else
        s = "0" + s;
      n /= 2;
    }
    return s;
  }
}